# all files / ol/format/ xsdformat.js

92.54% Statements 62/67
66.67% Branches 12/18
100% Functions 13/13
92.54% Lines 62/67

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    1851×

    1×
    1×
    1×
    1×

    1×

    1×
    16×
    16×

    1×
    61×
    61×
    20×

    41×

    1×
    10×
    10×

    10×
    10×
    10×
    10×
    10×
    10×
    10×
    10×
    10×
    10×

    10×

    1×
    165×
    165×

    1×

    201×
    201×
    185×

    16×

    1×
    478×
    478×

    1×
    507×
    507×
    498×

    9×

    1×
    631×

    1×
    2×

    1×
    10×
    10×

    10×

    1×
    24×
    24×

    1×

    4×
    4×

    4×
    4×

    1×
    355×

     goog.provide('ol.format.XSD');

    goog.require('goog.asserts');
    goog.require('goog.string');
    goog.require('ol');
    goog.require('ol.xml');

    /**
     * @const
     * @type {string}
     */
    ol.format.XSD.NAMESPACE_URI = 'http://www.w3.org/2001/XMLSchema';

    /**
     * @param {Node} node Node.
     * @return {boolean|undefined} Boolean.
     */
    ol.format.XSD.readBoolean = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      return ol.format.XSD.readBooleanString(s);
    };

    /**
     * @param {string} string String.
     * @return {boolean|undefined} Boolean.
     */
    ol.format.XSD.readBooleanString = function(string) {
      var m = /^\s*(true|1)|(false|0)\s*$/.exec(string);
      if (m) {
        return m[1] !== undefined || false;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {number|undefined} DateTime in seconds.
     */
    ol.format.XSD.readDateTime = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      var re =
          /^\s*(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})(Z|(?:([+\-])(\d{2})(?::(\d{2}))?))\s*$/;
      var m = re.exec(s);
      Eif (m) {
        var year = parseInt(m[1], 10);
        var month = parseInt(m[2], 10) - 1;
        var day = parseInt(m[3], 10);
        var hour = parseInt(m[4], 10);
        var minute = parseInt(m[5], 10);
        var second = parseInt(m[6], 10);
        var dateTime = Date.UTC(year, month, day, hour, minute, second) / 1000;
        Iif (m[7] != 'Z') {
          var sign = m[8] == '-' ? -1 : 1;
          dateTime += sign * 60 * parseInt(m[9], 10);
          if (m[10] !== undefined) {
            dateTime += sign * 60 * 60 * parseInt(m[10], 10);
          }
        }
        return dateTime;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {number|undefined} Decimal.
     */
    ol.format.XSD.readDecimal = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      return ol.format.XSD.readDecimalString(s);
    };

    /**
     * @param {string} string String.
     * @return {number|undefined} Decimal.
     */
    ol.format.XSD.readDecimalString = function(string) {
      // FIXME check spec
      var m = /^\s*([+\-]?\d*\.?\d+(?:e[+\-]?\d+)?)\s*$/i.exec(string);
      if (m) {
        return parseFloat(m[1]);
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {number|undefined} Non negative integer.
     */
    ol.format.XSD.readNonNegativeInteger = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      return ol.format.XSD.readNonNegativeIntegerString(s);
    };

    /**
     * @param {string} string String.
     * @return {number|undefined} Non negative integer.
     */
    ol.format.XSD.readNonNegativeIntegerString = function(string) {
      var m = /^\s*(\d+)\s*$/.exec(string);
      if (m) {
        return parseInt(m[1], 10);
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {string|undefined} String.
     */
    ol.format.XSD.readString = function(node) {
      return ol.xml.getAllTextContent(node, false).trim();
    };

    /**
     * @param {Node} node Node to append a TextNode with the boolean to.
     * @param {boolean} bool Boolean.
     */
    ol.format.XSD.writeBooleanTextNode = function(node, bool) {
      ol.format.XSD.writeStringTextNode(node, (bool) ? '1' : '0');
    };

    /**
     * @param {Node} node Node to append a TextNode with the dateTime to.
     * @param {number} dateTime DateTime in seconds.
     */
    ol.format.XSD.writeDateTimeTextNode = function(node, dateTime) {
      var date = new Date(dateTime * 1000);
      var string = date.getUTCFullYear() + '-' +
          goog.string.padNumber(date.getUTCMonth() + 1, 2) + '-' +
          goog.string.padNumber(date.getUTCDate(), 2) + 'T' +
          goog.string.padNumber(date.getUTCHours(), 2) + ':' +
          goog.string.padNumber(date.getUTCMinutes(), 2) + ':' +
          goog.string.padNumber(date.getUTCSeconds(), 2) + 'Z';
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the decimal to.
     * @param {number} decimal Decimal.
     */
    ol.format.XSD.writeDecimalTextNode = function(node, decimal) {
      var string = decimal.toPrecision();
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the decimal to.
     * @param {number} nonNegativeInteger Non negative integer.
     */
    ol.format.XSD.writeNonNegativeIntegerTextNode =
        function(node, nonNegativeInteger) {
      goog.asserts.assert(nonNegativeInteger >= 0, 'value should be more than 0');
      goog.asserts.assert(nonNegativeInteger == (nonNegativeInteger | 0),
          'value should be an integer value');
      var string = nonNegativeInteger.toString();
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the string to.
     * @param {string} string String.
     */
    ol.format.XSD.writeStringTextNode = function(node, string) {
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };